-- By Christopher Street
-- chris_street@usa.net

integer stat_bits
atom code_in_progress
sequence hashtree,LZW

constant powers2={#1,#2,#4,#8,#10,#20,#40,#80,#100,#200,#400,#800,#1000,#2000,
                  #4000,#8000,#10000,#20000,#40000,#80000,#100000,#200000,
                  #400000,#800000},
         hash=11003

function lowhi(integer i)
    return remainder(i,256)&floor(i/256)
end function

function find_hash(integer pre,integer suf)
    integer i,o
    i=remainder(xor_bits((pre*256),suf),hash)
    if i=0 then
        o=1
    else
        o=hash-i
    end if
    while 1 do
        if hashtree[i+1][1]=-1 then
            return i+1
        elsif hashtree[i+1][2]=pre and hashtree[i+1][3]=suf then
            return i+1
        else
            i=i-o
            if i<0 then
                i=i+hash
            end if
        end if
    end while
end function

function max_bits(integer num)
    for i=1 to 14 do
        if powers2[i]>=num then
            return i-1
        end if
    end for
end function

procedure append_code(integer handle,integer code)
    LZW=LZW&code
    if length(LZW)=255 then
        puts(handle,255&LZW)
        LZW={}
    end if
end procedure

procedure write_code(integer handle,integer no_bits,integer code)
    code_in_progress=code_in_progress+code*powers2[stat_bits+1]
    stat_bits=stat_bits+no_bits
    while stat_bits>7 do
        append_code(handle,and_bits(code_in_progress,255))
        code_in_progress=floor(code_in_progress/256)
        stat_bits=stat_bits-8
    end while
end procedure

function GIF_LZW_compressor(sequence pic,sequence pal,integer handle,
                            integer interlace)
    integer xdim,ydim,clear,EOI,code,bits,pre,suf,x,y,i,max,bits_color,done
    sequence rasters
    trace(1)
    stat_bits=0
    code_in_progress=0
    LZW={}
    hashtree=repeat({-1,-1,-1},hash)
    if handle=-1 then
        return 0
    end if
    xdim=length(pic[1])
    ydim=length(pic)
    bits_color=max_bits(length(pal))-1
    clear=powers2[bits_color+2]
    EOI=clear+1
    code=EOI+1
    bits=bits_color+2
    max=powers2[bits+1]
    if code=max then
        clear=4
        EOI=5
        code=6
        bits=bits+1
        max=max*2
    end if
    puts(handle,bits-1)    
    write_code(handle,bits,clear)
    rasters={}
    if interlace then
        for e=1 to 5 by 4 do
            for f=e to ydim by 8 do
                rasters=rasters&f
            end for
        end for
        for e=3 to ydim by 4 do
            rasters=rasters&e
        end for
        for e=2 to ydim by 2 do
            rasters=rasters&e
        end for
    else
        for e=1 to ydim do
            rasters=rasters&e
        end for        
    end if
    pre=pic[rasters[1]][1]
    x=2     y=1     done=0
    if x>xdim then  y=y+1   x=1 end if
    while 1 do
        while 1 do
            if not done then
                suf=pic[rasters[y]][x]
                x=x+1
                if x>xdim then
                    y=y+1
                    x=1
                    if y>ydim then
                        done=1
                    end if
                end if
                i=find_hash(pre,suf)
                if hashtree[i][1]=-1 then
                    exit
                else
                    pre=hashtree[i][1]
                end if
            else                
                write_code(handle,bits,pre)
                write_code(handle,bits,EOI)
                if stat_bits then
                    write_code(handle,bits,0)
                end if
                puts(handle,length(LZW)&LZW)
                puts(handle,0)
                hashtree={}
                return 1
            end if
        end while
        write_code(handle,bits,pre)
        hashtree[i]={code,pre,suf}
        pre=suf        
        code=code+1
        if code=max+1 then
            max=max*2
            if bits=12 then
                write_code(handle,bits,clear)
                hashtree=repeat({-1,-1,-1},hash)
                code=EOI+1
                bits=bits_color+2
                max=powers2[bits+1]
                if bits=2 then
                    clear=4
                    EOI=5
                    code=6
                    bits=3
                    max=max*2
                end if
            else
                bits=bits+1
            end if
        end if
    end while
end function

global function save_gif(sequence pic,sequence filename)
    integer bits_color,i,handle,xdim,ydim
    xdim=length(pic[2][1])
    ydim=length(pic[2])
    handle=open(filename,"wb")
    bits_color=max_bits(length(pic[1]))-1
    puts(handle,"GIF87a")
    puts(handle,remainder(xdim,256)&floor(xdim/256))
    puts(handle,remainder(ydim,256)&floor(ydim/256))
    puts(handle,208+bits_color&0&0)
    if length(pic[1])<powers2[bits_color+2] then
        pic[1]=append(pic[1],repeat({0,0,0},powers2[bits_color+2]-length(pic[1])))
    end if
    for e=1 to length(pic[1]) do
        puts(handle,pic[1][e][1..3])
    end for
    puts(handle,','&0&0&0&0&remainder(xdim,256)&floor(xdim/256))
    puts(handle,remainder(ydim,256)&floor(ydim/256)&bits_color)
    i=GIF_LZW_compressor(pic[2],pic[1],handle,0)
    puts(handle,';'&repeat(#1A,8))
    close(handle)
    return i
end function

global function extended_save_gif(sequence pic,sequence filename,
                                  object interlace,sequence comment,sequence
                                  pos)
    integer bits_color,i,handle,xdim,ydim,no_pics
    sequence LSD                --- that's L)ogical S)creen D)escriptor
    handle=open(filename,"wb")
    if handle=-1 then
        return 0
    end if
    if sequence(pic[1][1][1]) then
        no_pics=length(pic)
        bits_color=max_bits(length(pic[1][1]))-1
    else
        no_pics=1
        pic={pic}
        bits_color=max_bits(length(pic[1][1]))-1
    end if
    if length(pos) and length(pos)!=no_pics then
        return 0
    end if
    if no_pics>1 then
        if length(pos)<no_pics then
            return 0
        end if
        LSD={0,0}
        for e=1 to no_pics do
            if length(pic[e][2][1])+pos[e][1]-1>LSD[1] then
                LSD[1]=length(pic[e][2][1])+pos[e][1]-1
            end if
            if length(pic[e][2])+pos[e][2]-1>LSD[2] then
                LSD[2]=length(pic[e][2][2])+pos[e][2]-1
            end if
        end for
    else
        if length(pos) then
            LSD={length(pic[1][2][1])+pos[1][1],length(pic[1][2])+pos[1][2]}
        else
            LSD={length(pic[1][2][1]),length(pic[1][2])}
        end if
    end if
    xdim=LSD[1]     ydim=LSD[2]         LSD={}
    if sequence(interlace) then
        if length(interlace)!=no_pics then
            return 0
        end if
    end if
    puts(handle,"GIF89a")
    puts(handle,remainder(xdim,256)&floor(xdim/256))
    puts(handle,remainder(ydim,256)&floor(ydim/256))
    if no_pics=1 then
        puts(handle,208+bits_color&0&0)
        if length(pic[1][1])<powers2[bits_color+2] then
            pic[1][1]=append(pic[1][1],repeat({0,0,0},powers2[bits_color+2]-length(pic[1][1])))
        end if
        for e=1 to length(pic[1][1]) do
            puts(handle,pic[1][1][e][1..3])
        end for
    else
        puts(handle,80+bits_color&0&0)
    end if
    for e=1 to no_pics do
        bits_color=max_bits(length(pic[e][1]))-1
        xdim=length(pic[e][2][1])
        ydim=length(pic[e][2])
        if no_pics=1 then
            if not length(pos) then
                puts(handle,','&0&0&0&0&lowhi(xdim)&lowhi(ydim))
            else
                puts(handle,','&lowhi(pos[e][1])&lowhi(pos[e][2])&lowhi(xdim)&lowhi(ydim))
            end if
            if sequence(interlace) then
                puts(handle,bits_color+(64*(interlace[1]!=0)))
            else
                puts(handle,bits_color+(64*(interlace!=0)))
            end if
        else
            puts(handle,','&lowhi(pos[e][1])&lowhi(pos[e][2])&lowhi(xdim)&lowhi(ydim))
            if sequence(interlace) then
                puts(handle,bits_color+128+(64*(interlace[e]!=0)))
            else
                puts(handle,bits_color+128+(64*(interlace!=0)))
            end if
            if length(pic[e][1])<powers2[bits_color+2] then
                pic[e][1]=append(pic[e][1],repeat({0,0,0},powers2[bits_color+2]-length(pic[e][1])))
            end if
            for f=1 to length(pic[e][1]) do
                puts(handle,pic[e][1][f][1..3])
            end for
        end if
        if sequence(interlace) then
            i=GIF_LZW_compressor(pic[e][2],pic[e][1],handle,interlace[e])
        else
            i=GIF_LZW_compressor(pic[e][2],pic[e][1],handle,interlace)
        end if
    end for

    if length(comment) then
        puts(handle,#21&#FE)
        while length(comment)>255 do
            puts(handle,#FF&comment[1..255])
            comment=comment[256..length(comment)]
        end while
        puts(handle,length(comment)&comment&0)
    end if
    puts(handle,';'&repeat(#1A,8))
    close(handle)    
    return i
end function

global function save_pcx(sequence pic,sequence filename)
    integer handle,xdim,ydim,t,i,j
    sequence pal
    pal=pic[1]
    pic=pic[2]
    handle=open(filename,"wb")
    if handle=-1 then
        return 0
    end if
    -- Lots of secret header stuff
    xdim=length(pic[1])
    if remainder(xdim,2) then
        for e=1 to length(pic) do
            pic[e]=pic[e]&0
        end for
        xdim=xdim+1
    end if
    ydim=length(pic)
    puts(handle,10&5&1&8&0&0&0&0)
    puts(handle,remainder(xdim-1,256)&floor((xdim-1)/256))
    puts(handle,remainder(ydim-1,256)&floor((ydim-1)/256))
    puts(handle,remainder(xdim,256)&floor(xdim/256))
    puts(handle,remainder(ydim,256)&floor(ydim/256))
    puts(handle,0&0&0&216&152&56&120&116&4&112&108&4&236&
                172&76&248&196&128&64&36&36&36&40&20&248&
                188&104&212&144&156&60&36&36&116&112&8&
                120&116&8&124&120&8&52&48&4&240&196&136)
    puts(handle,0&1&remainder(xdim,256)&floor(xdim/256)&1&0&0&0&0&0&repeat(0,54))
    -- Actual pic encoding
    i=1     j=1
    while 1 do
        t=1
        if i!=xdim then
            while pic[j][i]=pic[j][i+1] do
                i=i+1       t=t+1
                if t=63 then exit end if
                if i=xdim then i=i-1 t=t-1 exit end if
            end while
        end if
        if t=1 then
            if and_bits(pic[j][i],192)=192 then
                puts(handle,193)
            end if
            puts(handle,pic[j][i])
        else
            puts(handle,t+192&pic[j][i])
        end if
        i=i+1
        if i=xdim+1 then
            i=1
            j=j+1
        end if
        if j=ydim+1 then
            exit
        end if
    end while
    puts(handle,12)
    for e = 1 to length(pal) do
        puts(handle,pal[e][1..3])
    end for
    if length(pal)<256 then
        for e=1 to 256-length(pal) do
            puts(handle,{0,0,0})
        end for
    end if
    close(handle)
    return 1
end function

global function save_targa(sequence pic,sequence filename,integer RLE)
    integer handle,index,i,x,c,last,mode
    sequence bytes,data
    handle=open(filename,"wb")
    if handle=-1 then
        return 0
    end if
    index=1
    if length(pic)!=2 then
        index=0
    end if
    if not RLE then
        if index then
            bytes={0,1,1,0,0}&lowhi(length(pic[1]))&24&0&0&0&0&
                lowhi(length(pic[2][1]))&lowhi(length(pic[2]))&8&0
            puts(handle,bytes)
            for e=1 to length(pic[1]) do
                i=pic[1][e][3]
                pic[1][e][3]=pic[1][e][1]
                pic[1][e][1]=i
                puts(handle,pic[1][e][1..3])
            end for
            for e=length(pic[2]) to 1 by -1 do
                puts(handle,pic[2][e])
            end for
        end if
    else
        if index then
            bytes={0,1,9,0,0}&lowhi(length(pic[1]))&24&0&0&0&0&
                lowhi(length(pic[2][1]))&lowhi(length(pic[2]))&8&0
            puts(handle,bytes)
            for e=1 to length(pic[1]) do
                i=pic[1][e][3]
                pic[1][e][3]=pic[1][e][1]
                pic[1][e][1]=i
                puts(handle,pic[1][e][1..3])
            end for
            data={}
            for e=length(pic[2]) to 1 by -1 do
                data=data&pic[2][e]
            end for
            pic={}
            x=2
            last=data[1]
            while 1 do
                if data[x]=last then
                    mode=1
                    c=2
                else
                    bytes={last,data[x]}
                    mode=0
                    c=2
                end if
                while 1 do
                    last=data[x]
                    x=x+1
                    if x=length(data) then exit end if
                    if data[x]=last and mode=1 then
                        c=c+1
                    elsif data[x]!=last and mode=0 then
                        c=c+1
                        bytes=bytes&data[x]
                    else
                        exit
                    end if                
                    if c=127 then
                        exit
                    end if
                end while
                c=c-1
                if mode=1 then
                    puts(handle,128+c)
                    puts(handle,last)
                    last=data[x]
                    x=x+1
                    if x>length(data) then
                        puts(handle,0&x)
                        exit
                    end if
                elsif mode=0 then
                    c=c-1
                    puts(handle,c)
                    puts(handle,bytes[1..c+1])
                    bytes={}
                end if
                if x>=length(data) then
                    exit
                end if
            end while
        end if
    end if
    close(handle)
    return 1
end function


